#include <msp/core/systemerror.h>
#include "handle.h"
#include "handle_private.h"

namespace Msp {
namespace IO {

void sys_set_blocking(Handle &, bool)
{
}

void sys_set_inherit(Handle &, bool)
{
}

unsigned sys_read(Handle &handle, char *buf, unsigned size)
{
	DWORD ret;
	if(ReadFile(*handle, buf, size, &ret, 0)==0)
		throw system_error("ReadFile");

	return ret;
}

unsigned sys_write(Handle &handle, const char *buf, unsigned size)
{
	DWORD ret;
	if(WriteFile(*handle, buf, size, &ret, 0)==0)
		throw system_error("WriteFile");

	return ret;
}

void sys_close(Handle &handle)
{
	if(handle)
	{
		CloseHandle(*handle);
		*handle = INVALID_HANDLE_VALUE;
	}
}

} // namespace IO
} // namespace Msp
